﻿-- Load the Global settings for the ADDON
WGSettings = {}

-- Loading local settings
local WG_NAME 		    = "Wintergrasper Advanced"
local WG_VERSION  		= GetAddOnMetadata("Wintergrasper_Advanced","Version")
local WG_DATA_VERSION	= GetAddOnMetadata("Wintergrasper_Advanced","X-Version") -- Database Version
local UpdateInterval    = 1
local playerName        = UnitName("player")
local currentServer     = GetRealmName()
local WGTimeSaved       = 0
local WG_RELEASETYPE    = "RELEASE" -- NIGHTLY/RELEASE

-- Create the SCT Frame for the messages to display
local frame=CreateFrame('MessageFrame', 'WG_SCTFRAME', UIParent)
frame:SetWidth(UIParent:GetWidth())
frame:SetWidth(600)
frame:SetHeight(60)
frame:SetFrameStrata('HIGH')
frame:SetTimeVisible(8)
frame:SetFadeDuration(0.4)
frame:SetPoint('CENTER', 0, 180)
frame:SetFontObject(GameFontNormalLarge)
frame:Show();

-- OnLoad function
function WG_OnLoad()

	this:RegisterEvent("VARIABLES_LOADED");
	this:RegisterEvent("PLAYER_ENTERING_WORLD");
	this:RegisterEvent("PLAYER_LOGIN");
	this:RegisterEvent("PLAYER_LOGOUT");
	this:RegisterEvent("UPDATE_WORLD_STATES");
	this:RegisterEvent("GOSSIP_SHOW");
	this:RegisterEvent("CHAT_MSG_CHANNEL");
	this:RegisterEvent("CHAT_MSG_WHISPER");
	this:RegisterEvent("CHAT_MSG_GUILD");
	this:RegisterEvent("CHAT_MSG_ADDON");
	this:RegisterEvent("CHAT_MSG_CHANNEL_NOTICE");
	this:RegisterEvent("CHAT_MSG_MONSTER_YELL");

	SLASH_WG1 = "/wg";
	SlashCmdList["WG"] = WG_SlashCommand;

	if( DEFAULT_CHAT_FRAME ) then
		DEFAULT_CHAT_FRAME:AddMessage("|c0000FF00"..WG_NAME.." v"..WG_VERSION..":|r |c00FFFFFFLOADED (/wg)|r");
	end
end

-- OnEvent Function
function WG_OnEvent(event, arg1,arg2,arg3,arg4,arg5,arg6,arg7,arg8,arg9)
	WGMapName = (select(1,GetMapInfo()))
	
	if (event == "VARIABLES_LOADED") then
	
	--Loads defauls on firstrun or update
	if(WGSettings.FirstLoad == nil or WGSettings.FirstLoad < WG_DATA_VERSION)then
		WG_OptionsFrame_SetDefaults();
	end
	
	if(WGSettings.showWindow)then WG_Window:Show(); else WG_Window:Hide(); end
		WG_Window:SetUserPlaced(true);
	end
	if (event=="PLAYER_ENTERING_WORLD")then
		--Minimap Button Info
		local info = {
			icon = "Interface\\Icons\\INV_Jewelry_Ring_66",
			position = 0,
			drag = "CIRCLE",
			left = function()
				if(WGSettings.SyncMode)then
					if(GetCurrentMapContinent() == 4)then
						WGAskChannel()
						if(WGTimeTillString ~= nil)then
							WGChannelTell(WGTimeTillString)
						end
						if(UnitIsDeadOrGhost("player") ~= 1)then
							WG_ControlCheck()
						end
					else
						WGAskChannel()
					end
				else
					if(GetCurrentMapContinent() == 4)then
						WGTimeTillString = WGConvertTime(GetWintergraspWaitTime())
						if(UnitIsDeadOrGhost("player") ~= 1)then
							WG_ControlCheck()
						end
					else
						print(WGNoSync)
					end
				end
			end,
			right = function()
				if(WG_Window:IsShown())then
					WG_Window:Hide()
				else
					WG_Window:Show()
				end
			end,
			tooltip = tooltiptext,
			enabled = "ON",
		}
		--Minimap Button Creation
		MyMinimapButton:Create("Wintergrasper_Advanced",WGSettings,info)
		-- Loader for Options with LDB Installed
		if(WGSettings.enableMMB) then 
			Wintergrasper_AdvancedMinimapButton:Show(); 
		else
			Wintergrasper_AdvancedMinimapButton:Hide();
		end
		-- End those Options
		if (GetCurrentMapContinent() == 4)then
			if(WGMapName ~= "LakeWintergrasp" and UnitIsDeadOrGhost("player") ~= 1)then
				WG_ControlCheck()
			end
			WGTimeTillString = WGConvertTime(GetWintergraspWaitTime())
		else
			if(WGTimeTillString == nil)then
				WG_WindowMessage:SetText("|cffFFCC00   "..WGNA.."|r")
			end
		end
	end
	if(event=="CHAT_MSG_CHANNEL_NOTICE")then
		if(WGSettings.SyncMode)then
			if(arg9=="WG")then
				if(GetCurrentMapContinent() == 4)then
					if(WGTimeTillString ~= nil)then
						WGChannelTell(WGTimeTillString)
					end
				else
					WGAskChannel();
				end
			else
				WGOnLoad()
			end
		end
		if(WGowner == nil and UnitIsDeadOrGhost("player") ~= 1)then
			WG_ControlCheck()
		end
		timethatloggedin = time()+10
	end
	if(event=="PLAYER_LOGIN")then
		UIDropDownMenu_Initialize(WGDropDownMenu, WGDropDownMenu_Initialize, "MENU");
		-- Options Text Loader
		WG_OptionsInitialize()
		mYell = 0;
		UpdateReminderShown = false
		timethatloggedin = time()+10
	end
	if(event=="PLAYER_LOGOUT")then
	end
	if(event == "UPDATE_WORLD_STATES")then
		if(WGMapName == "LakeWintergrasp") then
			if(select(3,GetWorldStateUIInfo(8)) ~= NIL)then
				if (WGowner == "InProgress") then 
					WGTimeTillString ="0:"..(select(3,GetWorldStateUIInfo(8)):match("%d%d:%d%d"))
				else 
					WGTimeTillString = (select(3,GetWorldStateUIInfo(8)):match("%d:%d%d:%d%d"))
				end
				
			end
		--	WG_ControlCheck()
		end
	end
    if event == "GOSSIP_SHOW" then
        if (UnitName("target") == BMNameA or UnitName("target") == BMNameH) and GetGossipText():find("%d:%d%d:%d%d") then 
            WGTimeTillString = string.split(";",GetGossipText():match("%d:%d%d:%d%d"))
			WGChannelTell(WGTimeTillString)
		elseif (UnitName("target") == BMNameA or UnitName("target") == BMNameH) and GetGossipText():find("%d%d:%d%d") then
			WGTimeTillString = "0:"..string.split(";",GetGossipText():match("%d%d:%d%d"))
			WGChannelTell(WGTimeTillString)
		elseif (UnitName("target") == BMNameA or UnitName("target") == BMNameH) and not GetGossipText():find("%d:%d%d:%d%d") then
			if(WGTimeTillString == nil)then
				WG_WindowMessage:SetText("|cffFFCC000:00:00")
			end
		end
		if (UnitName("target") == BMNameA or UnitName("target") == BMNameH) and GetGossipText():find("Орды") then 
			WGowner = "Horde"
		elseif (UnitName("target") == BMNameA or UnitName("target") == BMNameH) and GetGossipText():find("Альянса") then
			WGowner = "Alliance"
		end		
	end
	if(event == "CHAT_MSG_CHANNEL")then
		WGChanFunction(arg1,arg2,arg9)
	end
	if(event == "CHAT_MSG_GUILD")then
		WGChanFunction2(arg1,arg2)
	end
	if (event == "CHAT_MSG_WHISPER") then
		WGWhisper(arg1,arg2)
	end
	if(event == "CHAT_MSG_ADDON")then
		if(arg1 == "WGA")then
			WGUpdateCheck(arg2)
		end
	end
	if (event == "CHAT_MSG_MONSTER_YELL")then
	    if (arg2 == BMNameA or arg2 == BMNameH) and string.find(arg1, " 15") and mYell == 0 then 
			if (WGSettings.SCTDisplay) and not (WGMapName == "LakeWintergrasp")then
				WG_SCTFRAME:AddMessage(""..factionicon..""..WGWarn1, 0.7, 0.7, 1);
				WGTimeTillString = "0:14:59"
				WGPlaySound()
				mYell = 1;
				WGTimeSaved = time()
			end
			WGChannelTell(WGTimeTillString)
		elseif(arg2 == BMNameH or arg2 == BMNameA) and string.find(arg1, " 5") and mYell == 0 then
			if (WGSettings.SCTDisplay) and not (WGMapName == "LakeWintergrasp")then
				WG_SCTFRAME:AddMessage(""..factionicon..""..WGWarn2, 0.7, 0.7, 1);
				WGTimeTillString = "0:04:59"
				WGPlaySound()	
				mYell = 1;
				WGTimeSaved = time()
			end
			WGChannelTell(WGTimeTillString)
		end
	end
end 

function WGUpdateCheck(version)
	if(version > WG_VERSION and UpdateReminderShown == false)then
		if(WGSettings.showReminder)then
			WG_UpdateReminder(version)
		end
	end
end

-- Menu Function
function WG_SlashCommand()
	if(WG_OptionsFrame:IsShown())then
		WG_OptionsFrame:Hide()
	else
		WG_OptionsFrame:Show()
	end
end 

-- Time Creation functions (by Jini)
function WGMakeSeconds(WGGiven)
	WGHours = WGTimeHours(WGGiven)
	WGMinutes = WGTimeMinutes(WGGiven)
	WGSeconds = WGTimeSeconds(WGGiven)
	WGSeconds = tonumber(WGSeconds)
	WGMinutes = tonumber(WGMinutes)
	WGHours = tonumber(WGHours)

	if(WGHours==nil)then
		WGHours=0
	end
	if(WGMinutes==nil)then
		WGMinutes=0
	end
	if(WGSeconds==nil)then
		WGSeconds=0
	end
	if (WGHours == nil)then
		if(WGMinutes == nil)then
			WGTimeInSeconds = WGSeconds
		else
			WGTimeInSeconds = (WGMinutes*60)+WGSeconds
		end
		else
			WGTimeInSeconds = (WGHours*3600)+(WGMinutes*60)+WGSeconds
	end

		WGMakeTimeFromSeconds(WGTimeInSeconds)
	return WGTimeInSeconds
end

function WGTimeHours(WGGiven)
		WGtempHourss = WGGiven:match(".")
		WGtempHours = WGtempHourss:match(".")
	return WGtempHours
end

function WGTimeMinutes(WGGiven)
		WGtempMinutes = WGGiven:match("%d%d")
	return WGtempMinutes
end

function WGTimeSeconds(WGGiven)
		WGtempSeconds = WGGiven:gsub(".","",5)
	return WGtempSeconds
end

function WGMakeTimeFromSeconds(WGGiven)
-- Seconds to mm:ss string
	if((math.floor(WGGiven % 60)) < 10)then
		WGFinalTime = "0"..tostring(math.floor(WGGiven % 60))..""
		else
		WGFinalTime = tostring(math.floor(WGGiven % 60))..""    
    end
    if WGGiven >= 60 then 
        WGGiven = WGGiven / 60
        if((math.floor(WGGiven % 60)) < 10)then
        WGFinalTime = "0"..tostring(math.floor(WGGiven % 60))..':'..WGFinalTime
        else
        WGFinalTime = tostring(math.floor(WGGiven % 60))..':'..WGFinalTime
        end
    
        if WGGiven >= 60 then
            WGGiven = WGGiven / 60
            
            WGFinalTime = tostring(math.floor(WGGiven % 24))..':'..WGFinalTime
            if WGGiven >= 24 then
                WGGiven = WGGiven / 24
                WGFinalTime = tostring(math.floor(WGGiven))..'d'..WGFinalTime
            end
        else
            WGFinalTime = '0:'..WGFinalTime
            
        end
    else
    WGFinalTime = '0:00:'..WGFinalTime
    
    end
    --Jini
    return WGFinalTime
end

-- OnUpdate Function
function WG_OnUpdate(elapsed)
	local CurrentTime = GetTime()

	if (DelayTime == nil)then
		DelayTime = GetTime()
    end
	if(WGTimeSaved ~= nil)then
		if(mYell == 1 and (WGTimeSaved > time()+60 or WGTimeSaved == nil))then
			mYell = 0;
		end
	end
	if (WGTimeTillString == "0:00:00")then
		WGCheckTimeSCT();
		WGTimeTillString = nil
		WGowner = nil
	end
	if(GetCurrentMapContinent() == 4)then 
		if(GetWintergraspWaitTime() == nil)then
			WGowner = "InProgress"
			if(WGTimeTillString == nil)then
				WG_WindowMessage:SetText("|cffFFCC00"..WGSTARTED.."|r")
				if(IsAddOnLoaded("Wintergrasper_Advanced_LDB") ~= nil)then
					WGbroker.text = "|cffFFCC00"..WGSTARTED.."|r"
				end
			end
		end
	end
	if(timethatloggedin > time())then
		if(GetCurrentMapContinent() == 4)then
			WG_ControlCheck()
		end
	end
    if (WGTimeTillString ~= nil)then
		if(IsAddOnLoaded("Wintergrasper_Advanced_LDB") ~= nil)then
			WGbroker.text = WGTimeTillString
		end
		WGCountdown = WGMakeSeconds(WGTimeTillString)
		if (CurrentTime >= DelayTime) then
			DelayTime = CurrentTime + UpdateInterval
			WGCountdown = WGCountdown - UpdateInterval
			WGTimeTillString = WGMakeTimeFromSeconds(WGCountdown)
			WGUpdateTime(WGTimeTillString)
		end
    end
	WGCheckTimeSCT()
	WG_SetFactionTexture()
end

-- Sync functions
function WGOnLoad()
	RemoveChatWindowChannel(1, "WG")
	JoinTemporaryChannel("WG")
end

function WGUpdateTime(WGGiven)
	WGMapName = (select(1,GetMapInfo()))
	
	WG_WindowMessage:SetText(WGGiven)
end

function WGChannelTell(WGGiven)
	if(WGSettings.SyncMode)then
		WGOnLoad()
		if(WGowner~=nil)then
			SendChatMessage(""..WGGiven.." "..WGowner.."", "CHANNEL", nil, GetChannelName("WG"))
		else
			SendChatMessage(WGGiven, "CHANNEL",nil,GetChannelName("WG"))
		end
	end
end 

function WGAskChannel()
	WGOnLoad();
	if(GetCurrentMapContinent() == 4)then
		if(GetWintergraspWaitTime() == nil)then
			WGIsOnSCTAnnouncement()
		else
			WGTimeTillString = WGConvertTime(GetWintergraspWaitTime())
		end
	else
		SendChatMessage("ReSync","CHANNEL",nil,GetChannelName("WG"));
	end
end 

function WGChanFunction(msg,name,channel)
  WGMapName = (select(1,GetMapInfo()))

	if((channel == "Общий: Даларан" or channel == "Торговля: Город" or channel == "Оборона: Даларан" or channel == "Гильдия") and WGSettings.autoReplyTime)then
		if((string.find(msg, WG_AR_MAIN) or string.find(msg, WG_AR_MAIN2)) and ((string.find(msg,WG_AR_INCLUDE1) or string.find(msg,WG_AR_INCLUDE2))) and name ~= playerName)then
			WGAnnounce_REPLY(name)
		end
	end
	
	-- "string.find(msg,"2:29:50")" is a fix for the loop bug introduced in 1.50
	-- and should be removed sometime down the road.
	if not (channel == "WG")then
        return
    end
	if(WGMapName ~= "LakeWintergrasp")then
		if(name ~= playerName)then
			if(string.find(msg,"Horde"))then
				WGowner = "Horde"
			elseif(string.find(msg,"Alliance"))then
				WGowner = "Alliance"
			elseif(string.find(msg,"InProgress"))then
				WGowner = "InProgress"
				--WG_Window2:Show()
			end
		end
	end
	if(string.find(msg,"ReSync") and (WGTimeTillString ~= nil) and (name ~= playerName))then
				WGChannelTell(WGTimeTillString)
			elseif(string.match(msg,"%d:%d%d:%d%d"))then
				if not(string.find(msg,"2:29:50"))then
					WGTimeTillString = string.match(msg,"%d:%d%d:%d%d");
				end
	end	
end 

function WGChanFunction2(msg,name)
	if(WGSettings.autoReplyTime)then
		if((string.find(msg, WG_AR_MAIN) or string.find(msg, WG_AR_MAIN2)) and ((string.find(msg,WG_AR_INCLUDE1) or string.find(msg,WG_AR_INCLUDE2))) and name ~= playerName)then
			WGAnnounce_REPLY(name)
		end
	end
end

-- SCT functions
function WGCheckTimeSCT()
   WGMapName = (select(1,GetMapInfo()))
	if((GetWintergraspWaitTime() ~= nil and GetCurrentMapContinent() == 4)) or (GetCurrentMapContinent() ~= 4)then
		if (WGSettings.SCTDisplay) and not (WGMapName == "LakeWintergrasp") then
			if (WGTimeTillString == "0:15:00")then
				if (WGowner == "InProgress") then 
					WG_SCTFRAME:AddMessage(""..factionicon..""..WGWarn5, 0.7, 0.7, 1);
				else 
					WG_SCTFRAME:AddMessage(""..factionicon..""..WGWarn1, 0.7, 0.7, 1);
				end
				WGTimeTillString = "0:14:59"
				WGPlaySound()
				if (WGSettings.autoReplyTime) then 
					WGAnnounce_GUILD()
				end
			elseif (WGTimeTillString == "0:05:00")then
				if (WGowner == "InProgress") then 
					WG_SCTFRAME:AddMessage(""..factionicon..""..WGWarn6, 0.7, 0.7, 1);
				else 
					WG_SCTFRAME:AddMessage(""..factionicon..""..WGWarn2, 0.7, 0.7, 1);
				end
				WGTimeTillString = "0:04:59"
				WGPlaySound()
				if (WGSettings.autoReplyTime) then 
					WGAnnounce_GUILD()
				end
			elseif (WGTimeTillString == "0:00:00")then
				WG_SCTFRAME:AddMessage(""..factionicon..""..WGWarn4, 0.7, 0.7, 1);
				WGPlaySound()
				SendChatMessage("[WGA] "..WGWarn4.."", "GUILD", nil, nil)
			end
		end
	end
end 

function WGPlaySound()
	if(WGSettings.soundCheck)then
		if(WGSettings.CustomSoundSet)then
			PlaySoundFile("Interface\\AddOns\\Wintergrasper_Advanced\\Sounds\\alert.mp3")
		else
			PlaySoundFile("Sound\\Spells\\Blade_of_Azzinoth_Impact.wav")
		end
	end
end

function WGIsOnSCTAnnouncement()
	if(WGSettings.SCTDisplay)then
		WG_SCTFRAME:AddMessage(""..'\124TInterface\\AddOns\\Wintergrasper_Advanced\\Icons\\PvP-FFA.blp:40\124t '..""..WGWarn3, 0.7, 0.7, 1);
		WGPlaySound()
	end
end


function WGWhisper(message,sender)
	WGMapName = (select(1,GetMapInfo()))
	message=string.lower(message)
	
	if(string.find(message,WG_AR_WHISPER) and WGSettings.autoReplyTime)then
		WGAnnounce_REPLY(sender)
	end
end 

function WGConvertTime(value)
	if(value~=nil)then
		local hours = floor(value / 3600)
		local minutes = value - (hours * 3600)
		minutescorrupt = floor(minutes / 60)
		if(minutescorrupt < 10)then minutesfixed = "0"..minutescorrupt..""
		else minutesfixed = minutescorrupt end
		local seconds = floor(value - ((hours * 3600) + (minutescorrupt * 60)))
		if(seconds < 10)then secondsfixed = "0"..seconds..""
		else secondsfixed = seconds end
		if (hours > 0) then
			return hours..":"..minutesfixed..":"..secondsfixed
		elseif (minutescorrupt > 0) then
			return "0:"..minutesfixed..":"..secondsfixed
		else
			return "0:00:"..secondsfixed
		end
	else
		WGIsOnSCTAnnouncement()
	end
end


-- Dropdown Menu for Announce
function WG_OnMouseUp(self, button)
	if (button == "RightButton") then
		ToggleDropDownMenu(1, nil, WGDropDownMenu, "cursor");
		PlaySound("UChatScrollButton");
	end
end

function WGDropDownMenu_Initialize()
	local info;
	
	info = {};
	info.text =  WGAnnounceText;
	info.isTitle = 1;
	info.notCheckable = 1;
	UIDropDownMenu_AddButton(info);
	
	info = {};
	info.text = WGASAYTXT;
	info.func = WGAnnounce_SAY;
	info.notCheckable = 1;
	UIDropDownMenu_AddButton(info);
	
	info = {};
	info.text = WGAGUILDTXT;
	info.func = WGAnnounce_GUILD;
	info.notCheckable = 1;
	UIDropDownMenu_AddButton(info);
	
	info = {};
	info.text = WGATRADETXT;
	info.func = WGAnnounce_TRADE;
	info.notCheckable = 1;
	UIDropDownMenu_AddButton(info);
	
	info = {};
	info.text = WGARAIDTXT;
	info.func = WGAnnounce_RAID;
	info.notCheckable = 1;
	UIDropDownMenu_AddButton(info);
end 

function WGAnnounce_SAY()
	if(WGTimeTillString ~= nil)then
		if(UnitFactionGroup("player") == "Horde")then
			if(WGowner == "Horde")then
				SendChatMessage("[WGA] "..WGBegin2.." "..WGTimeTillString.."", "SAY", nil, nil)
			elseif(WGowner == "Alliance")then
				SendChatMessage("[WGA] "..WGBegin1.." "..WGTimeTillString.."", "SAY", nil, nil)
			elseif(WGowner == "InProgress")then
				SendChatMessage("[WGA] "..WGWarn7.." "..WGTimeTillString.."", "SAY", nil, nil);
			else
				SendChatMessage("[WGA] "..WGBegin.." "..WGTimeTillString.."", "SAY", nil, nil);
			end
		elseif(UnitFactionGroup("player") == "Alliance")then
			if(WGowner == "Horde")then
				SendChatMessage("[WGA] "..WGBegin1.." "..WGTimeTillString.."", "SAY", nil, nil);
			elseif(WGowner == "Alliance")then
				SendChatMessage("[WGA] "..WGBegin2.." "..WGTimeTillString.."", "SAY", nil, nil);
			elseif(WGowner == "InProgress")then
				SendChatMessage("[WGA] "..WGWarn7.." "..WGTimeTillString.."", "SAY", nil, nil);
			else
				SendChatMessage("[WGA] "..WGBegin.." "..WGTimeTillString.."", "SAY", nil, nil);
			end
		end
	elseif(WGowner == "InProgress")then
		SendChatMessage("[WGA] "..WGWarn3.."", "WHISPER", nil, P);
	end
end 
function WGAnnounce_REPLY(P)
	if(WGTimeTillString ~= nil)then
		if(UnitFactionGroup("player") == "Horde")then
			if(WGowner == "Horde")then
				SendChatMessage("[WGA] "..WGBegin2.." "..WGTimeTillString.."", "WHISPER", nil, P)
			elseif(WGowner == "Alliance")then
				SendChatMessage("[WGA] "..WGBegin1.." "..WGTimeTillString.."", "WHISPER", nil, P)
			elseif(WGowner == "InProgress")then
				SendChatMessage("[WGA] "..WGWarn7.." "..WGTimeTillString.."", "WHISPER", nil, P);
			else
				SendChatMessage("[WGA] "..WGBegin.." "..WGTimeTillString.."", "WHISPER", nil, P);
			end
		elseif(UnitFactionGroup("player") == "Alliance")then
			if(WGowner == "Horde")then
				SendChatMessage("[WGA] "..WGBegin1.." "..WGTimeTillString.."", "WHISPER", nil, P);
			elseif(WGowner == "Alliance")then
				SendChatMessage("[WGA] "..WGBegin2.." "..WGTimeTillString.."", "WHISPER", nil, P);
			elseif(WGowner == "InProgress")then
				SendChatMessage("[WGA] "..WGWarn7.." "..WGTimeTillString.."", "WHISPER", nil, P);
			else
				SendChatMessage("[WGA] "..WGBegin.." "..WGTimeTillString.."", "WHISPER", nil, P);
			end
		end
	elseif(WGowner == "InProgress")then
		SendChatMessage("[WGA] "..WGWarn3.."", "WHISPER", nil, P);
	end
end
function WGAnnounce_GUILD()
	if(WGTimeTillString ~= nil)then
		if(UnitFactionGroup("player") == "Horde")then
			if(WGowner == "Horde")then
				SendChatMessage("[WGA] "..WGBegin2.." "..WGTimeTillString.."", "GUILD", nil, nil)
			elseif(WGowner == "Alliance")then
				SendChatMessage("[WGA] "..WGBegin1.." "..WGTimeTillString.."", "GUILD", nil, nil)
			elseif(WGowner == "InProgress")then
				SendChatMessage("[WGA] "..WGWarn7.." "..WGTimeTillString.."", "GUILD", nil, nil);
			else
				SendChatMessage("[WGA] "..WGBegin.." "..WGTimeTillString.."", "GUILD", nil, nil);
			end
		elseif(UnitFactionGroup("player") == "Alliance")then
			if(WGowner == "Horde")then
				SendChatMessage("[WGA] "..WGBegin1.." "..WGTimeTillString.."", "GUILD", nil, nil);
			elseif(WGowner == "Alliance")then
				SendChatMessage("[WGA] "..WGBegin2.." "..WGTimeTillString.."", "GUILD", nil, nil);
			elseif(WGowner == "InProgress")then
				SendChatMessage("[WGA] "..WGWarn7.." "..WGTimeTillString.."", "GUILD", nil, nil);
			else
				SendChatMessage("[WGA] "..WGBegin.." "..WGTimeTillString.."", "GUILD", nil, nil);
			end
		end
	elseif(WGowner == "InProgress")then
		SendChatMessage("[WGA] "..WGWarn3.."", "GUILD", nil, nil);
	end
end
function WGAnnounce_TRADE()
	if(WGTimeTillString ~= nil)then
		if(UnitFactionGroup("player") == "Horde")then
			if(WGowner == "Horde")then
				SendChatMessage("[WGA] "..WGBegin2.." "..WGTimeTillString.."", "CHANNEL", nil, GetChannelName(WGTrade))
			elseif(WGowner == "Alliance")then
				SendChatMessage("[WGA] "..WGBegin1.." "..WGTimeTillString.."", "CHANNEL", nil, GetChannelName(WGTrade))
			elseif(WGowner == "InProgress")then
				SendChatMessage("[WGA] "..WGWarn7.." "..WGTimeTillString.."", "CHANNEL", nil, GetChannelName(WGTrade));
			else
				SendChatMessage("[WGA] "..WGBegin.." "..WGTimeTillString.."", "CHANNEL", nil, GetChannelName(WGTrade));
			end
		elseif(UnitFactionGroup("player") == "Alliance")then
			if(WGowner == "Horde")then
				SendChatMessage("[WGA] "..WGBegin1.." "..WGTimeTillString.."", "CHANNEL", nil, GetChannelName(WGTrade));
			elseif(WGowner == "Alliance")then
				SendChatMessage("[WGA] "..WGBegin2.." "..WGTimeTillString.."", "CHANNEL", nil, GetChannelName(WGTrade));
			elseif(WGowner == "InProgress")then
				SendChatMessage("[WGA] "..WGWarn7.." "..WGTimeTillString.."", "CHANNEL", nil, GetChannelName(WGTrade));
			else
				SendChatMessage("[WGA] "..WGBegin.." "..WGTimeTillString.."", "CHANNEL", nil, GetChannelName(WGTrade));
			end
		end
	elseif(WGowner == "InProgress")then
		SendChatMessage("[WGA] "..WGWarn3.."", "WHISPER", nil, P);
	end
end
function WGAnnounce_RAID()
	if(WGTimeTillString ~= nil)then
		if(UnitFactionGroup("player") == "Horde")then
			if(WGowner == "Horde")then
				SendChatMessage("[WGA] "..WGBegin2.." "..WGTimeTillString.."", "RAID", nil, nil)
			elseif(WGowner == "Alliance")then
				SendChatMessage("[WGA] "..WGBegin1.." "..WGTimeTillString.."", "RAID", nil, nil)
			elseif(WGowner == "InProgress")then
				SendChatMessage("[WGA] "..WGWarn7.." "..WGTimeTillString.."", "RAID", nil, nil);
			else
				SendChatMessage("[WGA] "..WGBegin.." "..WGTimeTillString.."", "RAID", nil, nil);
			end
		elseif(UnitFactionGroup("player") == "Alliance")then
			if(WGowner == "Horde")then
				SendChatMessage("[WGA] "..WGBegin1.." "..WGTimeTillString.."", "RAID", nil, nil);
			elseif(WGowner == "Alliance")then
				SendChatMessage("[WGA] "..WGBegin2.." "..WGTimeTillString.."", "RAID", nil, nil);
			elseif(WGowner == "InProgress")then
				SendChatMessage("[WGA] "..WGWarn7.." "..WGTimeTillString.."", "RAID", nil, nil);
			else
				SendChatMessage("[WGA] "..WGBegin.." "..WGTimeTillString.."", "RAID", nil, nil);
			end
		end
	elseif(WGowner == "InProgress")then
		SendChatMessage("[WGA] "..WGWarn3.."", "WHISPER", nil, P);
	end
end
function WGAnnounce_GENERAL()
	if(WGTimeTillString ~= nil)then
		if(UnitFactionGroup("player") == "Horde")then
			if(WGowner == "Horde")then
				SendChatMessage("[WGA] "..WGBegin2.." "..WGTimeTillString.."", "CHANNEL", nil, GetChannelName("General"))
			elseif(WGowner == "Alliance")then
				SendChatMessage("[WGA] "..WGBegin1.." "..WGTimeTillString.."", "CHANNEL", nil, GetChannelName("General"))
			elseif(WGowner == "InProgress")then
				SendChatMessage("[WGA] "..WGWarn7.." "..WGTimeTillString.."", "CHANNEL", nil, GetChannelName("General"));
			else
				SendChatMessage("[WGA] "..WGBegin.." "..WGTimeTillString.."", "CHANNEL", nil, GetChannelName("General"));
			end
		elseif(UnitFactionGroup("player") == "Alliance")then
			if(WGowner == "Horde")then
				SendChatMessage("[WGA] "..WGBegin1.." "..WGTimeTillString.."", "CHANNEL", nil, GetChannelName("General"));
			elseif(WGowner == "Alliance")then
				SendChatMessage("[WGA] "..WGBegin2.." "..WGTimeTillString.."", "CHANNEL", nil, GetChannelName("General"));
			elseif(WGowner == "InProgress")then
				SendChatMessage("[WGA] "..WGWarn7.." "..WGTimeTillString.."", "CHANNEL", nil, GetChannelName("General"));
			else
				SendChatMessage("[WGA] "..WGBegin.." "..WGTimeTillString.."", "CHANNEL", nil, GetChannelName("General"));
			end
		end
	elseif(WGowner == "InProgress")then
		SendChatMessage("[WGA] "..WGWarn3.."", "WHISPER", nil, P);
	end
end
function WGAnnounce_LOCALDEFENSE()
	if(WGTimeTillString ~= nil)then
		if(UnitFactionGroup("player") == "Horde")then
			if(WGowner == "Horde")then
				SendChatMessage("[WGA] "..WGBegin2.." "..WGTimeTillString.."", "CHANNEL", nil, GetChannelName("LocalDefense"))
			elseif(WGowner == "Alliance")then
				SendChatMessage("[WGA] "..WGBegin1.." "..WGTimeTillString.."", "CHANNEL", nil, GetChannelName("LocalDefense"))
			elseif(WGowner == "InProgress")then
				SendChatMessage("[WGA] "..WGWarn7.." "..WGTimeTillString.."", "CHANNEL", nil, GetChannelName("LocalDefense"));
			else
				SendChatMessage("[WGA] "..WGBegin.." "..WGTimeTillString.."", "CHANNEL", nil, GetChannelName("LocalDefense"));
			end
		elseif(UnitFactionGroup("player") == "Alliance")then
			if(WGowner == "Horde")then
				SendChatMessage("[WGA] "..WGBegin1.." "..WGTimeTillString.."", "CHANNEL", nil, GetChannelName("LocalDefense"));
			elseif(WGowner == "Alliance")then
				SendChatMessage("[WGA] "..WGBegin2.." "..WGTimeTillString.."", "CHANNEL", nil, GetChannelName("LocalDefense"));
			elseif(WGowner == "InProgress")then
				SendChatMessage("[WGA] "..WGWarn7.." "..WGTimeTillString.."", "CHANNEL", nil, GetChannelName("LocalDefense"));
			else
				SendChatMessage("[WGA] "..WGBegin.." "..WGTimeTillString.."", "CHANNEL", nil, GetChannelName("LocalDefense"));
			end
		end
	elseif(WGowner == "InProgress")then
		SendChatMessage("[WGA] "..WGWarn3.."", "WHISPER", nil, P);
	end
end
function WG_ControlCheck()
	if(GetCurrentMapContinent() == 4)then
		if(WGMapName == "LakeWintergrasp")then
			if(GetWintergraspWaitTime()~=nil)then
				if(select(2,GetWorldStateUIInfo(6)) == 1)then
					WGowner = "Horde"
				elseif(select(2,GetWorldStateUIInfo(5)) == 1)then
					WGowner = "Alliance"
				end
			else
				WGowner = "InProgress"
			end
		else
			if(GetWintergraspWaitTime()~=nil)then
				if(UnitBuff("player",WGBUFFNAME))then
					if(UnitFactionGroup("player") == "Horde")then
						WGowner = "Horde"
					elseif(UnitFactionGroup("player") == "Alliance")then
						WGowner = "Alliance"
					end
				else
					if(UnitFactionGroup("player") == "Horde")then
						WGowner = "Alliance"
					else
						WGowner = "Horde"
					end
				end
			else
				WGowner = "InProgress"
			end
		end
	else
		WGowner = 0
	end
	WG_SetFactionTexture()
end
function WG_SetFactionTexture()
	if(WGowner == "Horde")then
		WG_WindowToken:SetTexture("Interface\\AddOns\\Wintergrasper_Advanced\\Icons\\PvPHorde.blp")
		factionicon='\124TInterface\\AddOns\\Wintergrasper_Advanced\\Icons\\PvPHorde.blp:32\124t '
		if(IsAddOnLoaded("Wintergrasper_Advanced_LDB") ~= nil)then
			WGbroker.icon = "Interface\\AddOns\\Wintergrasper_Advanced\\Icons\\PvPHorde.blp"
		end
	elseif(WGowner == "Alliance")then
		WG_WindowToken:SetTexture("Interface\\AddOns\\Wintergrasper_Advanced\\Icons\\PvPAlliance.blp")
		factionicon='\124TInterface\\AddOns\\Wintergrasper_Advanced\\Icons\\PvPAlliance.blp:32\124t '
		if(IsAddOnLoaded("Wintergrasper_Advanced_LDB") ~= nil)then
			WGbroker.icon = "Interface\\AddOns\\Wintergrasper_Advanced\\Icons\\PvPAlliance.blp"
		end
	elseif(WGowner == "InProgress")then
		WG_WindowToken:SetTexture("Interface\\AddOns\\Wintergrasper_Advanced\\Icons\\PvP-FFA.blp")
		factionicon='\124TInterface\\AddOns\\Wintergrasper_Advanced\\Icons\\PvP-FFA.blp:40\124t '
		if(IsAddOnLoaded("Wintergrasper_Advanced_LDB") ~= nil)then
			WGbroker.icon = "Interface\\AddOns\\Wintergrasper_Advanced\\Icons\\PvP-FFA.blp"
		end
	else
		WG_WindowToken:SetTexture("Interface\\AddOns\\Wintergrasper_Advanced\\Icons\\QuestionMark.tga")
		factionicon='\124TInterface\\AddOns\\Wintergrasper_Advanced\\Icons\\QuestionMark.tga:20\124t '
		if(IsAddOnLoaded("Wintergrasper_Advanced_LDB") ~= nil)then
			WGbroker.icon = "Interface\\AddOns\\Wintergrasper_Advanced\\Icons\\QuestionMark.tga"
		end
	end
end

-- TestFunction
function WG_UpdateReminder(newVersion)
	UpdateReminderShown = true
	local frame = CreateFrame("Frame", nil, UIParent)
		frame:SetFrameStrata("DIALOG")
		frame:SetWidth(430)
		frame:SetHeight(90)
		frame:SetPoint("CENTER", 0, 200)
		frame:SetBackdrop({
		bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background",
		edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border", tile = true, tileSize = 32, edgeSize = 32,
		insets = {left = 8, right = 8, top = 8, bottom = 8},
	})
	local fontstring = frame:CreateFontString(nil, "ARTWORK", "GameFontNormal")
		fontstring:SetWidth(410)
		fontstring:SetHeight(0)
		fontstring:SetPoint("TOP", 0, -16)
		fontstring:SetText(NVTXT:format(newVersion))
	local editBox = CreateFrame("EditBox", nil, frame)
	do
		local editBoxLeft = editBox:CreateTexture(nil, "BACKGROUND")
		local editBoxRight = editBox:CreateTexture(nil, "BACKGROUND")
		local editBoxMiddle = editBox:CreateTexture(nil, "BACKGROUND")
		editBoxLeft:SetTexture("Interface\\ChatFrame\\UI-ChatInputBorder-Left")
		editBoxLeft:SetHeight(32)
		editBoxLeft:SetWidth(32)
		editBoxLeft:SetPoint("LEFT", -14, 0)
		editBoxLeft:SetTexCoord(0, 0.125, 0, 1)
		editBoxRight:SetTexture("Interface\\ChatFrame\\UI-ChatInputBorder-Right")
		editBoxRight:SetHeight(32)
		editBoxRight:SetWidth(32)
		editBoxRight:SetPoint("RIGHT", 6, 0)
		editBoxRight:SetTexCoord(0.875, 1, 0, 1)
		editBoxMiddle:SetTexture("Interface\\ChatFrame\\UI-ChatInputBorder-Right")
		editBoxMiddle:SetHeight(32)
		editBoxMiddle:SetWidth(1)
		editBoxMiddle:SetPoint("LEFT", editBoxLeft, "RIGHT")
		editBoxMiddle:SetPoint("RIGHT", editBoxRight, "LEFT")
		editBoxMiddle:SetTexCoord(0, 0.9375, 0, 1)
	end
		editBox:SetHeight(32)
		editBox:SetWidth(280)
		editBox:SetPoint("TOP", fontstring, "BOTTOM", -40, -9)
		editBox:SetFontObject("GameFontHighlight")
		editBox:SetTextInsets(0, 0, 0, 1)
		editBox:SetFocus()
		editBox:SetText("http://wga.hostcell.net/")
		editBox:HighlightText()
		editBox:SetScript("OnHide", function(self)
		if ChatFrameEditBox:IsVisible() then
			ChatFrameEditBox:SetFocus()
		end
	end)
	editBox:SetScript("OnTextChanged", function(self)
		editBox:SetText("http://wga.hostcell.net/")
		editBox:HighlightText()
	end)
	local button = CreateFrame("Button", nil, frame)
		button:SetHeight(24)
		button:SetWidth(75)
		button:SetPoint("CENTER", 150, -8)
		button:SetNormalFontObject("GameFontNormal")
		button:SetHighlightFontObject("GameFontHighlight")
		button:SetNormalTexture(button:CreateTexture(nil, nil, "UIPanelButtonUpTexture"))
		button:SetPushedTexture(button:CreateTexture(nil, nil, "UIPanelButtonDownTexture"))
		button:SetHighlightTexture(button:CreateTexture(nil, nil, "UIPanelButtonHighlightTexture"))
		button:SetText(BUTTONTXT1)
		button:SetScript("OnClick", function(self)
		frame:Hide()
	end)
end

function WG_announceVersion()
	SendAddonMessage( "WGA", WG_VERSION, "RAID" );
	SendAddonMessage( "WGA", WG_VERSION, "PARTY" );
--	SendAddonMessage( "WGA", WG_VERSION, "GUILD" );
end

function WGDropDownMenu_Cancel()
	PlaySound("UChatScrollButton");
end 